from amsdal_data.connections.implementations.sqlite_state import SqliteStateConnection as SqliteStateConnection
from amsdal_data.table_schemas.base import TableSchemaServiceBase as TableSchemaServiceBase
from amsdal_data.table_schemas.data_models.sql_table_column import SqlTableColumn as SqlTableColumn
from amsdal_data.table_schemas.implementations.mixins.sql_statements_mixin import SqlStatementsMixin as SqlStatementsMixin
from amsdal_utils.models.data_models.address import Address as Address
from amsdal_utils.models.data_models.table_schema import TableSchema as TableSchema
from typing import Any

class SqliteStateTableSchemaService(SqlStatementsMixin, TableSchemaServiceBase):
    connection: SqliteStateConnection
    def register_table(self, table_schema: TableSchema) -> tuple[str, bool]: ...
    def unregister_table(self, address: Address) -> None: ...
    def resolve_table_name(self, address: Address) -> str: ...
    @staticmethod
    def _build_select_table_name_statement(table_name: str) -> tuple[str, list[Any]]: ...
    def create_table(self, table_name: str, table_schema: TableSchema) -> None: ...
    def update_table(self, table_name: str, table_schema: TableSchema, table_columns: list[SqlTableColumn]) -> None: ...
    def register_internal_tables(self) -> None: ...
